program Xport;
type
  Tcmd= string[20];
const
  _lpt1 = $378;
  _lpt2 = $278;
  _lptx = $3BC;
var
  ba: word;
  cmd, Xcmd: Tcmd;
  data, offset:byte;
  Xdat: word;


procedure help;
begin
  writeln('---------------------------------------------');
  writeln('*** HELP INDEX of Xport - parallel (LPT) ***');
  writeln('');
  writeln('sba,ba,a $hhh = select base address,h=HEX,or type lpt1=378,lpt2=278,lptx=3BC');
  writeln('out,write,w $hh $h = write data to port + h= offset');
  writeln('in,read,r $h  = read port, h=offset');
  writeln('help,h        = show all available commands');
  writeln('bits          = show bits'' positions');
  writeln('q,exit,ex     = exit');
  writeln('');
  writeln('developed by async, http://asyncbrain.baf.cz');
end;

procedure wbits;
begin
  writeln('');
  writeln('#pins for CANNON 25 conector');
  writeln('');
  writeln('data register (offset=0)');
  writeln('0-7 = data, pins=2-9 (D1-D8)');
  writeln('');
  writeln('status register (offset=1)');
  writeln('bit7: /BUSY     pin 11');
  writeln('bit6: ACK       pin 10');
  writeln('bit5: PAPER OUT pin 12');
  writeln('bit4: SELECT    pin 13');
  writeln('bit3: ERROR     pin 15');
  writeln('bit2-0 reserved');
  writeln('');
  writeln('control register (offset=2)');
  writeln('bit7-6 reserved');
  writeln('nit5: 0=unidirect port, 1=bidirect port');
  writeln('bit4: IRQ enable');
  writeln('bit3: /SELECT IN pin 17');
  writeln('bit2: INIT       pin 16');
  writeln('bit1: /AUTO FEED pin 14');
  writeln('bit0: /STROBE    pin 1');
  writeln('');
end;


procedure downCase(var s: Tcmd);
var i,l: byte;
begin
  i:= length(s);
  for i:=1 to l do
    if (s[i]>#64) and (s[i]<#91) then s[i]:= char(ord(s[i]) + 32);
end;

procedure odmazMezirky(var instr: Tcmd);
begin
  while (instr[1]=#32) and (length(instr)>0) do {odmazani mezer....}
      delete(instr,1,1);
end;

procedure hexToInt(var s: Tcmd; var data: word);
var i, l, e, dat:word;
    OK: boolean;
begin
  dat:= 0;
  e:= 1;
  OK:= true;
  l:= length(s);
  for i:=l downto 1 do begin
    if s[i] in ['0'..'9'] then
      dat:= dat + e*(ord(s[i])-48)
    else begin
      if s[i] in ['a'..'f'] then
        dat:= dat + e*(ord(s[i])-87)
      else begin
        writeln('integer mismatch at position:',i);
        OK:= false;
      end;
    end;
    e:= e*$10;
  end;
  if OK then data:= dat;
end;

function hex(data: word): Tcmd;
var i, numCell, max:byte;
    s: Tcmd;
begin
  s:='';
  if data<$1000 then max:=3
    else max:=4;

  if data<$100 then max:=2;

  for i:=1 to max do begin
    numCell:= $000F and data;
    data:= data shr 4; {odmaz...}
    if numCell<10 then s:= char(numCell+48) + s;
    if numCell>9 then s:= char(numCell+55) + s;
  end;
  hex:= s;
end;

function bin(data: word): Tcmd;
var i, numCell, max:byte;
    s: Tcmd;
begin
  s:='';
  if data<$1000 then max:=12
    else max:=16;

  if data<$100 then max:=8;
  for i:=1 to max do begin
    case ($0001 and data) of
      1:s:= '1' + s;
      0:s:= '0' + s;
    end;
    data:= data shr 1;
  end;
  bin:= s;
end;

procedure sba(ad: word);
begin
  ba:= ad;
end;

procedure outp(data, offset:byte);
begin
  writeln('>data written:',hex(data),'at port ',hex(ba+offset));
  port[ba+offset]:= data;
end;

procedure inp(offset: byte);
begin
  data:= port[ba+offset];
  writeln('>DATA ',hex(data),' at ',hex(ba),' offset: ',hex(offset));
  writeln('binary:',bin(data));
end;


begin
  writeln('welcome to Xport, type "help" to get next info');
  ba:= _lpt1;
  repeat
    write('cmd:');
    readln(cmd);
    odmazMezirky(cmd);
    downCase(cmd);
    cmd:= cmd + ' '; {add space for next, or cut empty char from input}
    Xcmd:= copy(cmd, 1, pos(' ',cmd)-1);
    delete(cmd, 1, pos(' ',cmd)-1);
    odmazMezirky(cmd);

    if (Xcmd='help') or (Xcmd='cmd') or (Xcmd='h') then help;


    {****** SBA *******}
    if (Xcmd='sba') or (Xcmd='ba') or (Xcmd='a') then begin
      cmd:= cmd + ' '; {add space for next, or cut empty char from input}
      Xcmd:= copy(cmd, 1, pos(' ',cmd)-1); {copy addess!}
      if Xcmd = 'lpt1' then ba:= _lpt1 else
        if Xcmd = 'lpt2' then ba:= _lpt2 else
          if Xcmd = 'lptx' then ba:= _lptx else begin {any}
            if length(Xcmd)>0 then
              hexToInt(Xcmd, ba);{address}
          end;
      writeln('current base address:',hex(ba));
    end;

    {****** OUT *******}
    if (Xcmd='out') or (Xcmd='write') or (Xcmd='w')then begin
      cmd:= cmd + ' '; {add space for next, or cut empty char from input}
      Xcmd:= copy(cmd, 1, pos(' ',cmd)-1); {copy value}
      delete(cmd, 1, pos(' ',cmd)-1); {delete value}
      odmazMezirky(cmd);

      if length(Xcmd)>0 then begin
        hexToInt(Xcmd, Xdat); {store data}
        data:= Xdat;
        cmd:= cmd + ' '; {add space for next, or cut empty char from input}
        Xcmd:= copy(cmd, 1, pos(' ',cmd)-1); {copy offset}

        if length(Xcmd)>0 then begin
          hexToInt(Xcmd, Xdat);{store offset}
          offset:= Xdat;
        end
        else
          writeln('>using current offset: ',offset);

        if offset>2 then begin
          writeln('offset of of range! (max. 2)');
        end
        else begin
          outp(data, offset);
        end;
      end
      else
        writeln('no data specified!');
    end;


    {****** IN *******}
    if (Xcmd='in') or (Xcmd='read') or (Xcmd='r')then begin
      cmd:=cmd + ' '; {add space for next, or cut empty char from input}
      Xcmd:= copy(cmd, 1, pos(' ',cmd)-1); {copy value}
      delete(cmd, 1, pos(' ',cmd)-1); {delete value}
      odmazMezirky(cmd);

      if length(Xcmd) > 0 then begin
        hexToInt(Xcmd, Xdat); {store offset}
        offset:= Xdat;
      end
      else
        writeln('using old offset...');
      if offset>2 then begin
        writeln('offset of of range! (max. 2)');
      end
      else
        inp(offset);
    end;

    {****** BITS *******}
    if Xcmd='bits' then wbits;
  until (Xcmd='q') or (Xcmd='quit') or (Xcmd='exit') or (Xcmd='ex'); {Quit the program}
  help;
end.